.\"	$NetBSD: valloc.3,v 1.11 2003/04/16 13:34:40 wiz Exp $
.\"
.\" Copyright (c) 1980, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)valloc.3	8.1 (Berkeley) 6/4/93
.\"
.Dd June 4, 1993
.Dt VALLOC 3
.Os
.Sh NAME
.Nm valloc
.Nd aligned memory allocation function
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In stdlib.h
.Ft void *
.Fn valloc "size_t size"
.Sh DESCRIPTION
.Bf -symbolic
Valloc is obsoleted by the current version of
.Xr malloc 3 ,
which aligns page-sized and larger allocations.
.Ef
.Pp
The
.Fn valloc
function
allocates
.Fa size
bytes aligned on a page boundary.
It is implemented by calling
.Xr malloc 3
with a slightly larger request, saving the true beginning of the block
allocated, and returning a properly aligned pointer.
.Sh RETURN VALUES
The
.Fn valloc
function returns
a pointer to the allocated space if successful; otherwise
a null pointer is returned
.Sh HISTORY
The
.Fn valloc
function appeared in
.Bx 3.0 .
.Sh BUGS
A
.Em vfree
function has not been implemented.
